package com.gic.haoban.manage.web.controller;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.alibaba.fastjson.JSON;
import com.gic.haoban.common.utils.HaobanResponse;
import com.gic.haoban.manage.api.dto.StaffDTO;
import com.gic.haoban.manage.api.dto.WxEnterpriseDTO;
import com.gic.haoban.manage.api.service.StaffApiService;
import com.gic.haoban.manage.api.service.WxEnterpriseApiService;
import com.gic.haoban.manage.web.config.Config;
import com.gic.haoban.manage.web.errCode.HaoBanErrCode;
import com.gic.haoban.manage.web.interceptor.WebInterceptor;
import com.gic.haoban.manage.web.vo.InfoVo;
import com.gic.wechat.api.dto.qywx.UserDTO;
import com.gic.wechat.api.service.qywx.QywxCorpApiService;

@RestController
public class InfoController extends WebBaseController{
//	public static final  String siteId = "ww2c34dc56739bb105";

	@Autowired
	private QywxCorpApiService qywxCorpApiService;
	@Autowired
	private StaffApiService staffApiService;
	@Autowired
	private WxEnterpriseApiService wxEnterpriseApiService;
    private static Logger logger= LoggerFactory.getLogger(InfoController.class);

	@Autowired
	private Config config;
	@RequestMapping("get-info-by-code")
	public HaobanResponse getInfoByCode(String code) {
		String userDTOJson = qywxCorpApiService.getCodeSession(config.getWxSuiteid(),code);
		logger.info("userDTOJson=============>{}",userDTOJson);
		UserDTO user = JSON.parseObject(userDTOJson, UserDTO.class);
		String userId = user.getUserid();
		String corpId = user.getCorpid();
		WxEnterpriseDTO enterprise = wxEnterpriseApiService.getEnterpriseBycorpId(corpId);
		StaffDTO loginStaff = null;
		if(enterprise != null){
			loginStaff = staffApiService.selectByUserIdAndEnterpriseId(userId,enterprise.getWxEnterpriseId());
		}
		if(loginStaff == null){
			if(enterprise != null){
				staffApiService.wxGetAdd(userId,enterprise.getWxEnterpriseId());
				loginStaff = staffApiService.selectByUserIdAndEnterpriseId(userId,enterprise.getWxEnterpriseId());
			}
		}
		if(loginStaff == null){
			return resultResponse(HaoBanErrCode.ERR_600001);
		}
		
		String wxEnterpriseId = loginStaff.getWxEnterpriseId();
		WxEnterpriseDTO wxEnterpriseDTO = wxEnterpriseApiService.getOne(wxEnterpriseId);
		String accesstoken = qywxCorpApiService.getCorpAccessToken(wxEnterpriseDTO.getCorpid(), config.getWxSuiteid());
		InfoVo infoVo = new InfoVo();
		infoVo.setAccessToken(accesstoken);
		infoVo.setStaffId(loginStaff.getStaffId());
		infoVo.setWxEnterpriseId(wxEnterpriseId);
		infoVo.setStaffName(loginStaff.getStaffName());
		infoVo.setPhoneNumber(loginStaff.getPhoneNumber());
		infoVo.setNationcode(loginStaff.getNationCode());
		return resultResponse(HaoBanErrCode.ERR_1,infoVo);
		
	}

}
